(function (global) {
    "use strict";

    global.FRCC = global.FRCC || {};
    global.FRCC.Portal = global.FRCC.Portal || {};
    global.FRCC.Portal.Utilities = (function() {
        var openAccordian = function (id) {
            var imageId = id + "-image";
            var image = document.getElementById(imageId);
            var elem = document.getElementById(id);
            var accordian = document.getElementById(id + "-accordian")
            if(accordian.classList.contains("disabled")) {
                return;
            }
            if (elem.classList.contains("hidden")) {
                image.src="./../contact-us/down-arrow.svg";
                elem.classList.remove("hidden");
            } else {
                image.src="./../contact-us/side-arrow.svg";
                elem.classList.add("hidden");
            }
        };
		var searchForError = function (nameKey, myArray){
			if (myArray.Blob) {
				for (var i=0; i < myArray.Blob.length; i++) {
					if (myArray.Blob[i].Name["#text"] === nameKey) {
						return true;
					}
			}
		  if (!Array.isArray(myArray.Blob)) { 
			if (myArray.Blob.Name["#text"] === nameKey) {
				return true;
			}
		  }
    }
    return false;
  };
        var safeAjax = function safeAjax(ajaxOptions) {
            var deferredAjax = $.Deferred();
            shell.getTokenDeferred().done(function (token) {
                // Add headers for ajax
                if (!ajaxOptions.headers) {
                    $.extend(ajaxOptions, {
                        headers: {
                            "__RequestVerificationToken": token
                        }
                    });
                } else {
                    ajaxOptions.headers["__RequestVerificationToken"] = token;
                }
                $.ajax(ajaxOptions)
                    .done(function (data, textStatus, jqXHR) {
                        validateLoginSession(data, textStatus, jqXHR, deferredAjax.resolve);
                    }).fail(deferredAjax.reject); //ajax
            }).fail(function () {
                deferredAjax.rejectWith(this, arguments); // On token failure pass the token ajax and args
            });
            return deferredAjax.promise();
        };

        var appAjax = function(processingMsg, ajaxOptions) {
            notificationMsg.show(processingMsg);
            return safeAjax(ajaxOptions)
            .fail(function (response) {
                if (response.responseJSON) {
                alert("Error: " + response.responseJSON.error.message)
                } else {
                alert("Error: Web API is not available... ")
                }
            }).always(notificationMsg.hide);
        };

        var _isOldIE = function(userAgent) {
            var msie = userAgent.indexOf('MSIE');
            var trident = userAgent.indexOf('Trident/');
            if (msie > 0 || trident > 0) {
            // IE 10 or older
            return true;
            }
            // other browser, IE 11, or Edge
            return false;
        };

        var showIEWarning = function() {
            if (_isOldIE(navigator.userAgent))
            {
                var ieWarning = document.getElementById('ie-banner');
                ieWarning.setAttribute('style', 'display: block;');
            }
        };

        var getEnvironmentVariable = function(variableName) {
            if (window.sessionStorage.getItem(variableName))
            {
                return window.sessionStorage.getItem(variableName);
            }
            //TODO: retrieve from dataverse
		    var envVariableStorage = window.location.host.split(".")[0] + "EnvVariable";
            var envVarsSession = JSON.parse(window.sessionStorage.getItem(envVariableStorage));
			window.sasTokens = envVarsSession;
			sessionStorage.setItem(variableName, envVarsSession[variableName]);
			return envVarsSession[variableName];
			/*
            envVars["sas_token_account"] = envVarsSession.eyfrcc_AccountSASToken;
            envVars["sas_token_container"] = envVarsSession.eyfrcc_ContainerSASToken;
            envVars["container_name"] = envVarsSession.eyfrcc_blobcontainername;
            envVars["account_name"] = envVarsSession.eyfrcc_blobaccountname;*/
        };
		
		var setEnvironmentVariables = function() {
		  var envVariableStorage = window.location.host.split(".")[0] + "EnvVariable";
		  var storageData = window.sessionStorage.getItem(envVariableStorage);
		  if (!storageData || storageData == "{}") {
		    $(function(){
				$.ajax({
				  method: "GET",
				  url: "/EnvironmentVariables/"
				}).done(function (msg) {
				  var envVariable = JSON.parse(msg);
				  var envVariableStorage = window.location.host.split(".")[0] + "EnvVariable";
				  window.sessionStorage.setItem(envVariableStorage, JSON.stringify(envVariable));
				});
			  });
			};
		  }

        return {
            openAccordian: openAccordian,
			searchForError: searchForError,
            appAjax: appAjax,
            safeAjax: safeAjax,
            showIEWarning: showIEWarning,
            getEnvironmentVariable: getEnvironmentVariable,
			setEnvironmentVariables: setEnvironmentVariables,
        }
    })();

    global.FRCC.Portal.Notification = (function() {
        
        var $processingMsgEl = $('#processingMsg'),
        _msg = 'Processing...',
        _stack = 0,
        _endTimeout;

        var show = function(msg) {
            $processingMsgEl.text(msg || _msg);
            if (_stack === 0) {
            clearTimeout(_endTimeout);
            $processingMsgEl.show();
            }
            _stack++;
        };

        var hide = function() {
            _stack--;
            if (_stack <= 0) {
                _stack = 0;
                clearTimeout(_endTimeout);
                _endTimeout = setTimeout(function () {
                    $processingMsgEl.hide();
                }, 500);
            }
        };

        return {
            show: show,
            hide: hide,
        }
    })();

})(this);